
  * Star Raiders  Atari ST cartridge  version

*  Overwrite by TOS created basepage with values
* or this executable, after depacking, relocating
* and then just jump to basepage + $100 


*Rom cartridge

  org $FA0000
 
  dc.l	$abcdef42     *magic
  dc.l	0   * No further prg in cart.
  dc.l 	$40000000   * Bit 30 set - TOS APP


  dc.l 	deskrev
  dc.w 	%0111101000100100   *time, GEMDOS format
  dc.w 	%0011101011011010 *date - 2009, VI, 26 
  dc.l 	fin-deskrev
  dc.b	"STARRAID.PRG",0
  even




deskrev	*  Depack to basepage+256,
*relocate and run

	lea	gamc3+32(pc),a1
	move.l	4(sp),a2      *Basepage
	lea	228(a2),a4   *Depack with header
	move.l	a2,-(sp)
	bsr	depak3


	move.l	(sp)+,a5   *Basepage
	lea	256(a5),a1   *code
* Now reloc : 
	move.l     a1,a0
	lea  	-28(a0),a3   *Header
  	move.l     a1,d0
	add.l    	2(a3),a0   *Code  len for this prg
    	add.l    	6(a3),a0   *Data  len for this prg	

      	move.l	a0,a2 * reloc table begin


	tst.l	(a0)
	beq.s	corrbp *

	add.l	(a0)+,a1
	clr.l	d1
relol	add.l	d0,(a1)
bigd	
	move.b	(a0)+,d1
	beq.s	corrbp
	cmp.b	#1,d1
	bne.s	nmd
	lea	$FE(a1),a1
	bra.s	bigd
nmd	adda.l	d1,a1
	bra.s	relol
corrbp

	move.l	d0,8(a5)    * Replace  cart address with RAM address !

	MOVE.L	2(A3),$C(A5)
	MOVE.L	6(A3),$14(A5)
	MOVE.L	$A(A3),$1C(A5)
	MOVE.L	8(A5),D2
	MOVE.L	$C(A5),D1
	ADD.L	D2,D1
	MOVE.L	D1,$10(A5)
	MOVE.L	$14(A5),D2
	ADD.L	D2,D1
	MOVE.L	D1,$18(A5)



	lea  	6600(a0),a0    *


xy    	clr.l	(a2)+ * clear BSS area begin
        	cmp.l	a2,a0
       	bgt.s	xy 	  










	move.l	d0,a0
	jmp	(a0)






depak3	clr.l d0
	moveq    #6,d4
	moveq    #$3f,d5   *for masking bits 5-0

* Bit meaning:  7 - if set it's back referrer , if 0 then bits
* 6-0 give count of literals to copy
* if all bits are 0 it is terminator

* When bit 7 set, bit 6: if 1 then long distance back given by 2 following byte
*  bit 6: when 0  then short distance given by following 1 byte
*  bits 5-0  count of bytes referred. 
*  By short refer.  0 means 3, 1 means 4, etc  up to 66 .
*  By long refer.  0 means 4, 1 means 5, etc  up to 67 .


main3 	clr.w d0 *prep for dbf
	move.b (a1)+,d0
	bmi.s back3 
	beq.s nom3 *end
	subq.w #1,d0 *compens dbf
litc 	move.b (a1)+,(a4)+
	dbf d0,litc
	bra.s main3

nom3	rts

back3	move.b d0,d2
	and.w d5,d2 *d5=$3f
* Test is long or short referrer:
	btst    d4,d0   *test bit 6
	bne.s  longr
	
	addq.w #2,d2 *compens	
displl	move.b (a1)+,d0 * displac
calcadr	move.l a4,a2
	sub.l d0,a2
baksl	move.b (a2)+,(a4)+
	dbf d2,baksl
	bra.s main3

longr	addq.w #3,d2 *compens
	move.b (a1)+,d0 * displac
	lsl.w  #8,d0   *MSB
	bra.s   displl

* End of C3 depak


gamc3    incbin   "STRAID.FIC"

   even

fin



